<?php if(!defined('IS_CMS')) die();

/***************************************************************
*
* Keywords und Description Plugin für moziloCMS.
*
***************************************************************/

class MyTitle extends Plugin {

    function getContent($value) {

        if(defined("PLUGINADMIN")) {
            $settings_array = $this->settings->toArray();
            if(getRequestValue('savemytitle',"post",false)) {
                if(getRequestValue('mytitle',"post",false) and is_array(getRequestValue('mytitle',"post",false))) {
                    $post_array = getRequestValue('mytitle',"post",false);
                    # aufräumen
                    foreach($settings_array as $cat_page => $tmp) {
                        if(strstr($cat_page,FILE_START) !== false and strstr($cat_page,FILE_END) !== false) {
                            if(!array_key_exists($cat_page, $post_array))
                                $this->settings->delete($cat_page);
                        }
                    }
                    foreach($post_array as $cat_page => $value) {
                        $this->settings->set($cat_page,$value);
                    }
                }
            } elseif(getRequestValue('clearmytitle',"post",false)) {
                foreach($settings_array as $cat_page => $tmp) {
                    if(strstr($cat_page,FILE_START) !== false and strstr($cat_page,FILE_END) !== false)
                    $this->settings->delete($cat_page);
                }
            }
            return $this->getAdmin();
        }

        if($value == "plugin_first") {
            global $CatPage;
            $cat = $_GET['cat'];
            if(!$cat) {
                global $CMS_CONF;
                $cat = $CMS_CONF->get("defaultcat");
            }
            $page = $_GET['page'];
            if(!$page and $CatPage->exists_CatPage($cat,false)) {
                $page = $CatPage->get_FirstPageOfCat($cat);
            }
            if($this->settings->keyExists(FILE_START.$cat.":".$page.FILE_END)) {
                $setting = $this->settings->get(FILE_START.$cat.":".$page.FILE_END);
                if(is_array($setting)) {
                    global $template;
                    if(strlen($setting['title']) > 2)
                        $template = str_replace('{WEBSITE_TITLE}',$setting['title'],$template);
                }
            }
        }
        return null;
    }

    function getConfig() {
        if(IS_ADMIN and $this->settings->get("plugin_first") !== "true") {
            $this->settings->set("plugin_first","true");
        }
        $config = array();
        $config["--admin~~"] = array(
            "buttontext" => "Bearbeiten",
            "description" => "Hier kannst du für jede Inhaltsseite einen eigenen Titel vergeben.",
            "datei_admin" => "index.php"
        );
        return $config;
    }

    function getInfo() {
            $info = array(
            // Plugin-Name + Version
            "<b>MyTitle</b>",
            // moziloCMS-Version
            "2.0",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            'Eigene Titel für jede Inhaltsseite.<br />
            Im <b>Bearbeiten</b> Fenster kannst du für jede Inhaltseite einen eigenen Titel eintragen.<br />
            Wenn Du keinen Titel einträgst, wird der Titel aus den CMS-Admin-Einstellungen verwendet.<br />
            Dieses Plugin benötigt <b>keinen eigenen Platzhalter</b>, da es den Platzhalter "<b>{WEBSITE_TITLE}</b>" verwendet.',
            // Name des Autors
            "maiemi - Danke an stefanbe für die Vorlage MetaKeyDescription",
            // Download-URL
            "http://www.mozilo.de/forum/index.php?action=media",
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array()
        );
        return $info;
    }

    function getAdmin() {
        global $CatPage;

        $title = array();
        if($this->settings->get("title") and is_array($this->settings->get("title")))
            $description = $this->settings->get("title");
        
        $html = '<div id="admin-mytitle">'
        .'<form name="allentries" action="'.URL_BASE.ADMIN_DIR_NAME.'/index.php" method="POST">'
        .'<input type="hidden" name="pluginadmin" value="'.PLUGINADMIN.'" />'
        .'<input type="hidden" name="action" value="'.ACTION.'" />'
        .'<div id="admin-mytitle-menu" class="ui-widget-content ui-corner-all">'
        .'<input type="submit" class="admin-mytitle-submit" name="savemytitle" value="Speichern" /> '
        .'<input type="submit" class="admin-mytitle-submit" name="clearmytitle" value="Alle Einträge Löschen" /><br />'
        .'</div>'
        .'<div id="admin-mytitle-content">'
        .'<ul id="admin-mytitle-content-ul" class="mo-ul">';
        foreach ($CatPage->get_CatArray(false,false,array(EXT_PAGE,EXT_HIDDEN)) as $cat) {
            $html .= '<li class="mo-li ui-widget-content ui-corner-all"><div class="admin-mytitle-cat">'.$CatPage->get_HrefText($cat,false).'</div>'
            .'<ul class="mo-in-ul-ul">';
            foreach ($CatPage->get_PageArray($cat,array(EXT_PAGE,EXT_HIDDEN),true) as $page) {
                $html .= '<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix"><b>'.$CatPage->get_HrefText($cat,$page).'</b><br />';
                $keyToCheck = FILE_START.$cat.":".$page.FILE_END;
                $in_title = '';
                if($this->settings->keyExists($keyToCheck)) {
                    $setting = $this->settings->get($keyToCheck);
                    if(is_array($setting)) {
                        $in_title = $setting['title'];
                     }
                }
                $html .= '<span>Seiten-Titel:</span> <input class="admin-mytitle-in" name="mytitle['.$keyToCheck.'][title]" type="text" size="100" maxlength="255" value="'.$in_title.'" /><br />'
                 .'</li>';
            }
            $html .= '</ul></li>';
        }
        return $html.'</ul></div></form></div>';
    }
}
?>