<?php if(!defined('IS_CMS')) die();
class jQback2top extends Plugin {
    function getContent($value) {
        if(empty($value))
            $value = "&#9650;";

        $hide_top = 50;
        if(is_numeric($this->settings->get("hide_top")))
            $hide_top = $this->settings->get("hide_top");
        $scroll_speed = 550;
        if(is_numeric($this->settings->get("scroll_speed")))
            $scroll_speed = $this->settings->get("scroll_speed");
        $scroll_to = 0;
        if(is_numeric($this->settings->get("scroll_to")))
            $scroll_to = $this->settings->get("scroll_to");
        $fade_speed = 500;
        if(is_numeric($this->settings->get("fade_speed")))
            $fade_speed = $this->settings->get("fade_speed");

        $content = '<script type="text/javascript">'
            .'$(function() {'
                # den button in var hinterlegen
                .'var jqback2top_button = $("#jqback2top");'
                .'$(jqback2top_button).hide(0);'
                .'$(window).scroll(function(){'
                    # Default=50 - Trigger zur Anzeige von jQback2top-Link ab vertikal XXX Pixel Scrolling
                    .'if($(window).scrollTop() > '.$hide_top.')'
                        .'$(jqback2top_button).fadeIn('.$fade_speed.');'
                    .'else ' # Lehrzeichen ist wichtig
                        .'$(jqback2top_button).fadeOut('.$fade_speed.');'
                .'});'
                .'$(jqback2top_button).click(function(event){'
                    .'event.preventDefault();' # stoppt die action vom a tag vgl. return false
                    # Default=550 - Scrollspeed in Millisekunden
                    .'$("html, body").animate({scrollTop:'.$scroll_to.'},'.$scroll_speed.');'
                .'});'
            .'});'
        .'</script>';
        global $syntax;
        $syntax->insert_jquery_in_head("jquery");
        $syntax->insert_in_head($content);
        # durch Verwendung von #a0 statt #top Funktion auch ohne js
        return '<a href="#a0" id="jqback2top">'.$value.'</a>';
    }
    function getConfig() {
        $config = array();
        $config['deDE']['hide_top'] = array(
            "type" => "text",
            "maxlength" => "5",
            "size" => "4",
            "description" => "Scrollposition - Ab Position X von oben Link einblenden. Default=50",
            "regex" => "/^\d{1,5}$/",
            "regex_error" => 'Zahl 0-99999 erlaubt!'
        );
        $config['deDE']['scroll_speed'] = array(
            "type" => "text",
            "maxlength" => "5",
            "size" => "4",
            "description" => "Scrollgeschwindigkeit - Verzögerung in Millisekunden. Default=550",
            "regex" => "/^\d{1,5}$/",
            "regex_error" => 'Zahl 0-99999 erlaubt!'
        );
        $config['deDE']['scroll_to'] = array(
            "type" => "text",
            "maxlength" => "5",
            "size" => "4",
            "description" => "Scrollziel - Bis zu Position X von oben scrollen. Default=0",
            "regex" => "/^\d{1,5}$/",
            "regex_error" => 'Zahl 0-99999 erlaubt!'
        );
        $config['deDE']['fade_speed'] = array(
            "type" => "text",
            "maxlength" => "5",
            "size" => "4",
            "description" => "Linkaus-/einblendung - Zeit in Millisekunden. Default=500",
            "regex" => "/^\d{1,5}$/",
            "regex_error" => 'Zahl 0-99999 erlaubt!'
        );
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        if(isset($config[$language]))
            return $config[$language];
        return $config['deDE'];
    }
    function getInfo() {
        $info = array();
        $info['deDE'] = array(
            // Plugin-Name + Version
            "<b>jQback2top</b> Revision 6",
            // moziloCMS-Version
            "2.0",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            '<b>jQback2top</b> - Automatische, weiche Einblendung (Fade) eines Softscroll-Toplinks nach vertikalem Scrolling.<br />
			Erzeugt auch -ohne Ankerlink- einen variablen Textlink mit weichem / verzögertem<br />
			Scrolling zum vertikalen Browser-Seitenkopf / zu Zeile 0 bzw. einstellbarer Wunschzeile gemessen in Pixel.<br />
			Trigger für Einblendung, Einblendungsgeschwindigkeit und Scrollgeschwindigkeit/Verzögerung sind im Plugin anpassbar.<br />
			Die optische Anpassung erfolgt im CMS-Admin via Template/Plugins CSS Datei/jQback2top/plugin.css<br />
			Der gewünschte Anzeigetext wird beim Aufruf im Template (optimal am Ende vor dem HTML-End-Tag) wie<br />
			gewohnt übergeben. Als Default(=keine Texteingabe) ist ein Hochdreieck hinterlegt. <br />
			Es kann statt eigenem Text auch ein Bild in der CMS-Syntax verwendet werden. Beispiele:<br />
			{jQback2top|nach oben}<br />
			{jQback2top|[fett|nach oben]}<br />
			{jQback2top|[bild|DAS BILD]}<br />
			Neben dem Seiten-Template sollte auch der Einbau in einzelne Inhaltsseiten problemlos arbeiten.<br />
			Benötigt eingeschaltetes Javascript für die Effekte (Ein-/Ausblenden und Softscrolling).',
            // Name des Autors
            "wasp und stefanbe",
            // Docu-URL
            "",
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array(
                '{jQback2top}' => 'mit &#9650; Zeichen',
                '{jQback2top|}' => 'Beliebiger Text oder Bild',
            )
        );
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        if(isset($info[$language]))
            return $info[$language];
        return $info['deDE'];
    }
}
?>